use std::fs;

fn parse_steps(lines: std::str::Lines) -> Vec<Vec<Vec<u32>>> {
    let mut steps: Vec<Vec<Vec<u32>>> = Vec::new();
    let mut step: Vec<Vec<u32>> = Vec::new();
    for line in lines {
        if line.contains("-to-") {
            step = Vec::new();
            steps.push(step);
        } else if line != "" {
            let numbers: Vec<&str> = line.split(" ").collect();
            let numbers: Vec<u32> = numbers
                .iter()
                .map(|string| {
                    let number: u32 = string.parse().unwrap();
                    number
                })
                .collect();
            let n = steps.len();
            steps[n - 1].push(numbers);
        }
    }
    steps
}

fn main() {
    let filepath: &str = "../../data/sample.txt";

    let contents = fs::read_to_string(filepath).expect("Should have been hable to read the file");

    let mut lines = contents.lines();
    let seeds: Vec<&str> = lines
        .next()
        .unwrap()
        .split(": ")
        .nth(1)
        .expect("Should have a seed")
        .split(" ")
        .collect();
    let steps = parse_steps(lines);
    for step in steps {
        println!("{:?}", step);
    }
    let seeds: Vec<u32> = seeds
        .iter()
        .map(|string| {
            let number: u32 = string.trim().parse().unwrap();
            number
        })
        .collect();
    for seed in seeds {
        println!("{:?}", seed);
    }
}
